' module: play "Pairs"

namespace PAIRS
  declare function callback(exercise as TExercise) as long
  declare function settings(exercise as TExercise, optional as long = SETTING_OPTIONS.NONE) as long
end namespace

globalExercises.add(TExercise("pairs", localize("pairsTitle"), "full", 0, _
                   @PAIRS.callback, 0, @PAIRS.settings, "", "games"))

function PAIRS.callback(exercise as TExercise) as long
  dim as integer W = 150, H = 60, Xstart = 50, Ystart = 50, Xplus = 180, yPlus = 100
  dim as integer card(3, 4), x, y, size, mx, my, mb, mb2, fSize
  dim as string key, tempString
  dim as double timer_
  dim as mdList(TWord) words
  if exercise.currentList.size then
    words = randomWord(exercise.currentList, 10)
  else
    words = randomWord(exercise.fullList, 10)
  end if
  size = words.size
  dim as FB.Image ptr cardImg(20)
  dim as string tempTxt
  for i as integer = 1 to size
    do
      x = int(rnd*4)
      y = int(rnd*5)
    loop until card(x, y) = 0
    card(x, y) = i
    do
      x = int(rnd*4)
      y = int(rnd*5)
    loop until card(x, y) = 0
    card(x, y) = i+10
  next

  dim as integer LBxHelp = 50, LBxExit = 640, LBxOutp = 250, LBy = 570, LBw = 110, LBh = 30, LBp = 20
  dim as integer posHelp = 1, posExit = 2, try = 0
  dim pairsGui as TGui, event as TGuiEvent
  pairsGui.addElement _
      TGuiElement(GuiElementType.button, posHelp, _
                  exepath & "/img/help.bmp", LBxHelp, LBy, 40, 40, chr(255, 59),, "", GuiState.noBorder)
  pairsGui.addElement _
      TGuiElement(GuiElementType.button, posExit, LBxExit, LBy+10, LBw, LBh, localize("back"), chr(27))
  
  for i as integer = 0 to 20
    cardImg(i) = imagecreate(W, H)
    line cardImg(i), (0, 0)-(W-1, H-1), &hff000000, bf
    line cardImg(i), (3, 3)-(W-5, H-5), iif(i = 0, &hffffdf7f, &hffffffff), bf
    select case i
      case 0       : centerFT cardImg(i), "?", font, 24
      case 1 to 10
        tempString = words.get(i-1).word
        fSize = iif(FTsize(tempString, font, 15).x > W - 10, 13, 15) 
        centerFT cardImg(i), tempString, font, fSize
      case else
        tempString = words.get(i-11).translate.get(0)
        fSize = iif(FTsize(tempString, font, 15).x > W - 10, 13, 15) 
        centerFT cardImg(i), tempString, font, fSize
    end select
  next
  cls
  screenlock
  for x as integer = 0 to 3
    for y as integer = 0 to 4
      if card(x, y) > 0 then put (x*Xplus+Xstart, y*Yplus+Ystart), cardImg(0), pset
    next
  next
  pairsGui.show
  printFT LBxOutp, LBy+10, localize("countTries") & ": " & try, font
  screenunlock

  do
    do
      getmouse mx, my,, mb
      sleep 1
    loop until mb = 0
    dim as integer x1 = -1, y1 = -1, x2 = -1, y2 = -1
    do
      key = inkey
      if key = chr(255, 107) then exit do, do
      event = pairsGui.getEvent(key)
      select case event.id
        case posHelp
          dim as integer ret = showHelpScreen(MODULE_PATH & "doc.htm", "pairs")
          if ret = RETVAR.windowClosed then key = chr(255, 107) : exit do, do
        case posExit
          if message(localize("askQuit"), localize("yes|no"), 2) = 1 then exit do, do
      end select
      for x as integer = 0 to 3
        for y as integer = 0 to 4
          if card(x, y) andalso checkMouseIn(x*Xplus+Xstart, y*Yplus+Ystart, W, H, 1) <> 0 then
            if x1 >= 0 andalso x1 = x and y1 = y then continue for
            if x1 >= 0 then
              x2 = x : y2 = y
            else
              x1 = x : y1 = y
            end if
            flipCard x*Xplus+Xstart, y*Yplus+Ystart, cardImg(0), cardImg(card(x, y))
            put (x*Xplus+Xstart, y*Yplus+Ystart), cardImg(card(x, y)), pset
            exit for, for
          end if
        next
      next
      sleep 1
    loop until x2 >= 0
    timer_ = timer
    mb = 1
    try += 1
    screenlock
    line (LBxOutp, LBy)-step(300, 30), &hffffff, bf
    printFT LBxOutp, LBy+10, localize("countTries") & ": " & try, font
    screenunlock
    do
      key = inkey
      if key = chr(255, 107) then exit do, do
      event = pairsGui.getEvent(key)
      select case event.id
        case posHelp
          dim as integer ret = showHelpScreen(MODULE_PATH & "doc.htm", "pairs")
          if ret = RETVAR.windowClosed then key = chr(255, 107) : exit do, do
        case posExit
          if message(localize("askQuit"), localize("yes|no"), 2) = 1 then exit do, do
      end select
      getmouse mx, my,, mb2
      if (mb = 0 and mb2 > 0) or len(key) then exit do
      mb = mb2
      sleep 1
    loop until timer - timer_ > 1.5
    if abs(card(x1, y1) - card(x2, y2)) = 10 then
      flipCard x1*Xplus+Xstart, y1*Yplus+Ystart, cardImg(card(x1, y1))
      flipCard x2*Xplus+Xstart, y2*Yplus+Ystart, cardImg(card(x2, y2))
      card(x1, y1) = 0
      card(x2, y2) = 0
      size -= 1
    else
      flipCard x1*Xplus+Xstart, y1*Yplus+Ystart, cardImg(card(x1, y1)), cardImg(0)
      put (x1*Xplus+Xstart, y1*Yplus+Ystart), cardImg(0), pset
      flipCard x2*Xplus+Xstart, y2*Yplus+Ystart, cardImg(card(x2, y2)), cardImg(0)
      put (x2*Xplus+Xstart, y2*Yplus+Ystart), cardImg(0), pset
    end if
  loop until size = 0
  for i as integer = 0 to 20
    imagedestroy cardImg(i)
  next
  select case key
    case chr(255, 107) : return RETVAR.windowClosed
    case chr(27)       : return RETVAR.aborted
    case else          : return RETVAR.ok
  end select
end function

function PAIRS.settings(exercise as TExercise, optional as long = SETTING_OPTIONS.NONE) as long
  return chooseWords(exercise, exercise.settingString, optional or SETTING_OPTIONS.SHOWTAGS)
end function
