' module: lists grammatical rules (verb conjugation at the moment)
#include once "include/showWords.bi"

namespace GRAMMARSCHEME
  declare function callback(exercise as TExercise) as long
end namespace

globalOptions.add(TExercise("grammarscheme", "Grammatik-Überblick", "full", 0, @GRAMMARSCHEME.callback, 0, 0))

function GRAMMARSCHEME.callback(exercise as TExercise) as long
  dim as TWord conj, tempWord(0 to 2)
  dim as integer posX(0 to 2) = { 50, 300, 550 }, posY(0 to 3) = { 100, 260, 420 }, posY2(0 to 1) = { 150, 320 }
  dim as integer buttonX = 50, buttonY = 590, buttonW = 95, buttonH = 25, buttonDist = 15
  dim as integer linePitch = 18, conjSize = 14,  mode(2), subj
  static as integer selection = 1
  dim as string person(1 to 6) = { "yo", "tú", "él/ella", "nosotr.", "vosotr.", "ellos/-as" }, key
  tempWord(0).word = "hablar"
  tempWord(1).word = "comer"
  tempWord(2).word = "recibir"

  dim grammarGui as TGui, event as TGuiEvent
  dim as TGuiElement button(1 to 6)
  button(1) = TGuiElement(GuiElementType.button, 1, buttonX,                        buttonY, buttonW, buttonH, "Indicativo")
  button(2) = TGuiElement(GuiElementType.button, 2, buttonX+(buttonW+buttonDist),   buttonY, buttonW, buttonH, "Subjuntivo")
  button(3) = TGuiElement(GuiElementType.button, 3, buttonX+(buttonW+buttonDist)*2, buttonY, buttonW, buttonH, "Compuesto")
  button(4) = TGuiElement(GuiElementType.button, 4, buttonX+(buttonW+buttonDist)*3, buttonY, buttonW, buttonH, "Futuro")
  button(5) = TGuiElement(GuiElementType.button, 5, buttonX+(buttonW+buttonDist)*4, buttonY, buttonW, buttonH, "Cond./Imper.")
  button(6) = TGuiElement(GuiElementType.button, 6, SCREEN_X-buttonX-buttonW,       buttonY, buttonW, buttonH, "zurück")
  button(selection).state = GuiState.activated
  for i as integer = 1 to 6
    grammarGui.addElement button(i)
  next

  do
    screenlock
    cls
    centerFT SCREEN_X\2, 40, "Konjugation der regelmäßige Verben", font, 20
    select case selection
      case 1, 2
        subj = iif(selection = 2, INFLECT.SUBJ, 0)
        centerFT SCREEN_X\2, 60, iif(subj, "Modo subjuntivo", "Modo indicativo"), font, 16
        printFT posX(0), posY(0)-.5*linePitch, "Presente", font, conjSize
        printFT posX(0), posY(1)-.5*linePitch, "Pretérito imperfecto", font, conjSize
        printFT posX(0), posY(2)-.5*linePitch, iif(subj, "Pretérito imperfecto (alternative Form)", _
                                                         "Pretérito indefinido"), font, conjSize
        for p as integer = 1 to 3
          for w as integer = 0 to 2
            ' presente
            conj = conjugSpanish(tempWord(w), INFLECT.PRES or p or subj)
            printFT posX(w), posY(0)+p*linePitch, person(p), font, conjSize
            printFT posX(w)+80, posY(0)+p*linePitch, conj.word, font, conjSize
            conj = conjugSpanish(tempWord(w), INFLECT.PRES or (p + INFLECT.PLURAL) or subj)
            printFT posX(w), posY(0)+(p+3)*linePitch, person(p+3), font, conjSize
            printFT posX(w)+80, posY(0)+(p+3)*linePitch, conj.word, font, conjSize
            ' pretérito imperfecto
            conj = conjugSpanish(tempWord(w), INFLECT.PRETIMP or p or subj)
            printFT posX(w), posY(1)+p*linePitch, person(p), font, conjSize
            printFT posX(w)+80, posY(1)+p*linePitch, conj.word, font, conjSize
            conj = conjugSpanish(tempWord(w), INFLECT.PRETIMP or (p + INFLECT.PLURAL) or subj)
            printFT posX(w), posY(1)+(p+3)*linePitch, person(p+3), font, conjSize
            printFT posX(w)+80, posY(1)+(p+3)*linePitch, conj.word, font, conjSize
            ' pretérito indefinido
            conj = conjugSpanish(tempWord(w), INFLECT.PRETIND or p or subj)
            printFT posX(w), posY(2)+p*linePitch, person(p), font, conjSize
            printFT posX(w)+80, posY(2)+p*linePitch, conj.word, font, conjSize
            conj = conjugSpanish(tempWord(w), INFLECT.PRETIND or (p + INFLECT.PLURAL) or subj)
            printFT posX(w), posY(2)+(p+3)*linePitch, person(p+3), font, conjSize
            printFT posX(w)+80, posY(2)+(p+3)*linePitch, conj.word, font, conjSize
          next
        next
      case 3
        centerFT SCREEN_X\2, 60, "Perfecto compuesto, Pluscuamperfecto, Pretérito anterior", font, 16
        printFT posX(0), posY2(0)-2*linePitch, "Modo indicativo", font, 16
        printFT posX(1), posY2(0)-2*linePitch, "Modo subjuntivo", font, 16
        printFT posX(0), posY2(0)-.5*linePitch, "Perfecto compuesto", font, conjSize
        printFT posX(1), posY2(0)-.5*linePitch, "Perfecto compuesto", font, conjSize
        printFT posX(0), posY2(1)-.5*linePitch, "Pluscuamperfecto", font, conjSize
        printFT posX(1), posY2(1)-.5*linePitch, "Pluscuamperfecto", font, conjSize
        printFT posX(2), posY2(0)-.5*linePitch, "Pretérito anterior", font, conjSize
        for p as integer = 1 to 3
          ' perfecto
          conj = conjugSpanish(tempWord(0), INFLECT.PERF or p)
          printFT posX(0), posY2(0)+p*linePitch, person(p), font, conjSize
          printFT posX(0)+80, posY2(0)+p*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.PERF or (p + INFLECT.PLURAL))
          printFT posX(0), posY2(0)+(p+3)*linePitch, person(p+3), font, conjSize
          printFT posX(0)+80, posY2(0)+(p+3)*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.PERF or p or INFLECT.SUBJ)
          printFT posX(1), posY2(0)+p*linePitch, person(p), font, conjSize
          printFT posX(1)+80, posY2(0)+p*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.PERF or (p + INFLECT.PLURAL))
          printFT posX(1), posY2(0)+(p+3)*linePitch, person(p+3), font, conjSize
          printFT posX(1)+80, posY2(0)+(p+3)*linePitch, conj.word, font, conjSize
          ' pluscuamperfecto
          conj = conjugSpanish(tempWord(0), INFLECT.PQPERF or p)
          printFT posX(0), posY2(1)+p*linePitch, person(p), font, conjSize
          printFT posX(0)+80, posY2(1)+p*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.PQPERF or (p + INFLECT.PLURAL))
          printFT posX(0), posY2(1)+(p+3)*linePitch, person(p+3), font, conjSize
          printFT posX(0)+80, posY2(1)+(p+3)*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.PQPERF or p or INFLECT.SUBJ)
          printFT posX(1), posY2(1)+p*linePitch, person(p), font, conjSize
          printFT posX(1)+80, posY2(1)+p*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.PQPERF or (p + INFLECT.PLURAL) or INFLECT.SUBJ)
          printFT posX(1), posY2(1)+(p+3)*linePitch, person(p+3), font, conjSize
          printFT posX(1)+80, posY2(1)+(p+3)*linePitch, conj.word, font, conjSize
          ' pretérito anterior
          conj = conjugSpanish(tempWord(0), INFLECT.PERFANT or p)
          printFT posX(2), posY2(0)+p*linePitch, person(p), font, conjSize
          printFT posX(2)+80, posY2(0)+p*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.PERFANT or (p + INFLECT.PLURAL))
          printFT posX(2), posY2(0)+(p+3)*linePitch, person(p+3), font, conjSize
          printFT posX(2)+80, posY2(0)+(p+3)*linePitch, conj.word, font, conjSize
        next
        printFT posX(2)+40, posY2(1)+2*linePitch, "Partizip-Formen:", font, conjSize
        printFT posX(2)+40, posY2(1)+4*linePitch, "hablar", font, conjSize
        printFT posX(2)+90, posY2(1)+4*linePitch, "- hablado", font, conjSize
        printFT posX(2)+40, posY2(1)+5*linePitch, "comer", font, conjSize
        printFT posX(2)+90, posY2(1)+5*linePitch, "- comido", font, conjSize
        printFT posX(2)+40, posY2(1)+6*linePitch, "recivir", font, conjSize
        printFT posX(2)+90, posY2(1)+6*linePitch, "- recivido", font, conjSize
      case 4
        centerFT SCREEN_X\2, 60, "Futuro", font, 16
        printFT posX(0), posY(0)-.5*linePitch, "Indicativo", font, conjSize
        printFT posX(0), posY(1)-.5*linePitch, "Subjuntivo", font, conjSize
        printFT posX(0), posY(2)-.5*linePitch, "Futuro perfecto ind.", font, conjSize
        printFT posX(1), posY(2)-.5*linePitch, "Futuro perfecto sub.", font, conjSize
        for p as integer = 1 to 3
          for w as integer = 0 to 2
            ' indicativo
            conj = conjugSpanish(tempWord(w), INFLECT.FUTSIMP or p)
            printFT posX(w), posY(0)+p*linePitch, person(p), font, conjSize
            printFT posX(w)+80, posY(0)+p*linePitch, conj.word, font, conjSize
            conj = conjugSpanish(tempWord(w), INFLECT.FUTSIMP or (p + INFLECT.PLURAL))
            printFT posX(w), posY(0)+(p+3)*linePitch, person(p+3), font, conjSize
            printFT posX(w)+80, posY(0)+(p+3)*linePitch, conj.word, font, conjSize
            ' subjuntivo
            conj = conjugSpanish(tempWord(w), INFLECT.FUTSIMP or p or INFLECT.SUBJ)
            printFT posX(w), posY(1)+p*linePitch, person(p), font, conjSize
            printFT posX(w)+80, posY(1)+p*linePitch, conj.word, font, conjSize
            conj = conjugSpanish(tempWord(w), INFLECT.FUTSIMP or (p + INFLECT.PLURAL) or INFLECT.SUBJ)
            printFT posX(w), posY(1)+(p+3)*linePitch, person(p+3), font, conjSize
            printFT posX(w)+80, posY(1)+(p+3)*linePitch, conj.word, font, conjSize
          next
          ' compuesto indicativo
          conj = conjugSpanish(tempWord(0), INFLECT.FUTCOMP or p)
          printFT posX(0), posY(2)+p*linePitch, person(p), font, conjSize
          printFT posX(0)+80, posY(2)+p*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.FUTCOMP or (p + INFLECT.PLURAL))
          printFT posX(0), posY(2)+(p+3)*linePitch, person(p+3), font, conjSize
          printFT posX(0)+80, posY(2)+(p+3)*linePitch, conj.word, font, conjSize
          ' compuesto subjuntivo
          conj = conjugSpanish(tempWord(0), INFLECT.FUTCOMP or p or INFLECT.SUBJ)
          printFT posX(1), posY(2)+p*linePitch, person(p), font, conjSize
          printFT posX(1)+80, posY(2)+p*linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(0), INFLECT.FUTCOMP or (p + INFLECT.PLURAL) or INFLECT.SUBJ)
          printFT posX(1), posY(2)+(p+3)*linePitch, person(p+3), font, conjSize
          printFT posX(1)+80, posY(2)+(p+3)*linePitch, conj.word, font, conjSize
        next
        printFT posX(2)+40, posY(2)+2*linePitch, "Partizip-Formen:", font, conjSize
        printFT posX(2)+40, posY(2)+4*linePitch, "hablar", font, conjSize
        printFT posX(2)+90, posY(2)+4*linePitch, "- hablado", font, conjSize
        printFT posX(2)+40, posY(2)+5*linePitch, "comer", font, conjSize
        printFT posX(2)+90, posY(2)+5*linePitch, "- comido", font, conjSize
        printFT posX(2)+40, posY(2)+6*linePitch, "recivir", font, conjSize
        printFT posX(2)+90, posY(2)+6*linePitch, "- recivido", font, conjSize
      case 5
        centerFT SCREEN_X\2, 60, "Condicional, Imperativo", font, 16
        printFT posX(0), posY(0)-.5*linePitch, "Condicional", font, conjSize
        printFT posX(0), posY(1)-.5*linePitch, "Condicional perfecto", font, conjSize
        printFT posX(0), posY(2)-.5*linePitch, "Imperativo afirmativo", font, conjSize
        printFT posX(1), posY(2)-.5*linePitch, "Imperativo negativo", font, conjSize
        for w as integer = 0 to 2
          for p as integer = 1 to 3
            ' condicional
            conj = conjugSpanish(tempWord(w), INFLECT.COND or p)
            printFT posX(w), posY(0)+p*linePitch, person(p), font, conjSize
            printFT posX(w)+80, posY(0)+p*linePitch, conj.word, font, conjSize
            conj = conjugSpanish(tempWord(w), INFLECT.COND or (p + INFLECT.PLURAL))
            printFT posX(w), posY(0)+(p+3)*linePitch, person(p+3), font, conjSize
            printFT posX(w)+80, posY(0)+(p+3)*linePitch, conj.word, font, conjSize
            ' condicional perfecto
            conj = conjugSpanish(tempWord(w), INFLECT.CONDPERF or p)
            printFT posX(w), posY(1)+p*linePitch, person(p), font, conjSize
            printFT posX(w)+80, posY(1)+p*linePitch, conj.word, font, conjSize
            conj = conjugSpanish(tempWord(w), INFLECT.CONDPERF or (p + INFLECT.PLURAL))
            printFT posX(w), posY(1)+(p+3)*linePitch, person(p+3), font, conjSize
            printFT posX(w)+80, posY(1)+(p+3)*linePitch, conj.word, font, conjSize
          next
          ' imperativo
          conj = conjugSpanish(tempWord(w), INFLECT.IMPERAT or 2)
          printFT posX(w), posY(2)+linePitch, person(2), font, conjSize
          printFT posX(w)+80, posY(2)+linePitch, conj.word, font, conjSize
          conj = conjugSpanish(tempWord(w), INFLECT.IMPERAT or (2 + INFLECT.PLURAL))
          printFT posX(w), posY(2)+2*linePitch, person(5), font, conjSize
          printFT posX(w)+80, posY(2)+2*linePitch, conj.word, font, conjSize
        next
        printFT posX(0), posY(2)+5*linePitch, _
            "Der Imperativ in den anderen Personen sowie der verneinende Imperativ-Formen werden mithilfe der", _
            font, conjSize
        printFT posX(0), posY(2)+6*linePitch, "Subjunctiv-Formen gebildet." , font, conjSize
    end select
    grammarGui.show
    screenunlock
    do
      event = grammarGui.getEvent
      key = inkey
      if key = chr(255, 107) then return RETVAR.windowClosed
      sleep 1
    loop until event.id
    if event.id < 6 then
      button(selection).state = GuiState.active
      grammarGui.setElement button(selection)
      selection = event.id
      button(selection).state = GuiState.activated
      grammarGui.setElement button(selection)
    end if
  loop until event.id = 6
  return RETVAR.ok
end function
