' specific defines for common modules

' functions and defines for global exercises
enum ImageType
  none = 0, alert, check
end enum
namespace PRETTOUT
  const NONE = 0, HINT1 = 1, HINT2 = 2, OBJ = 4, ARTICLE = 8, BOTHGEN = 16
  const FULL = ARTICLE or BOTHGEN
end namespace

declare function flexionLang1(w as TWord, inflection as integer) as TWord
declare function flexionLang2(w as TWord, inflection as integer, no as integer = 0) as string
declare function prettyOutput(w as TWord, setting as integer, byref col as uinteger = 0, _
                              byref extraLine as string = "", byref img as ImageType = ImageType.none) as TWord

const MAX_WORDLENGTH = 35
const MODIFY_SEARCH_SIMPLE = MODIFY_TOLOWER or MODIFY_NOUMLAUT
const SPECIAL_KEYS = "áéíóúñ¡äöüßÁÉÍÓÚÑ¿ÄÖÜ"
const SIMPLE_UPPER = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
const EXTEND_UPPER = SIMPLE_UPPER & "ÑÜ"
const FULL_UPPER   = EXTEND_UPPER & "ÁÉÍÓÚ"

const HANGMAN_KEYLENGTH = 10

function flexionLang1(w as TWord, inflection as integer) as TWord
  select case w.groupname
    case "verb"
      dim as TWord ret = conjugSpanish(w, inflection)
      return ret
    case "noun", "adjective"
      dim as TWord ret = declinSpanish(w, inflection)
      return ret
    case else
      return w
  end select
end function

function flexionLang2(w as TWord, inflection as integer, no as integer = 0) as string
  select case w.groupname
    case "verb"
      return conjugGerman(w, inflection, no)
    case "noun", "adjective"
      return declinGerman(w, inflection, no)
    case else
      return w.translate.get(no)
  end select
end function

function prettyOutput(w as TWord, setting as integer, byref col as uinteger = 0, _
                      byref extraLine as string = "", byref img as ImageType = ImageType.none) as TWord
  dim as TWord ret
  col = rgb(0, 0, 0)
  dim as string tempString, fem = ""
  if w.groupname = "noun" then
    tempString = getArticle(w) & w.word 
    select case w.map.get("genus")
      case "f"
        col = rgb(255, 0, 0)
      case "m"
        fem = w.map.get("f")
        col = iif(len(fem), 0, rgb(0, 0, 255))
      case else
        col = 0
    end select
  end if
  if setting and PRETTOUT.ARTICLE then
    ret.word = getArticle(w, setting and PRETTOUT.BOTHGEN) & w.word
  else
    ret.word = w.word
  end if
  if setting and PRETTOUT.BOTHGEN andalso len(fem) then
    if w.map.get("num") = "pl" then
      select case left(fem, len(fem)-2)
        case w.word, left(w.word, len(w.word)-2)
          ret.word &= "/-" & right(fem, 2)
        case else
          ret.word &= "/" & fem
      end select
    else
      select case left(fem, len(fem)-1)
        case w.word, left(w.word, len(w.word)-1)
          ret.word &= "/-" & right(fem, 1)
        case else
          ret.word &= "/" & fem
      end select
    end if
  end if
  if setting and PRETTOUT.HINT1 then
    tempString = w.map.get("hint-es")
    if len(tempString) then ret.word &= " (" & tempString & ")"
  end if
  if setting and PRETTOUT.HINT2 then
    tempString = w.map.get("hint-de")
    ret.translate.add w.translate.get(0) & iif(len(tempString), " (" & tempString & ")", "")
  else
    ret.translate.add w.translate.get(0)
  end if
  for i as integer = 1 to w.translate.size - 1
    ret.translate.add w.translate.get(i)
  next
  if len(w.map.get("irr")) then
    extraLine = replace(w.map.get("irr"), "→", "->")
    if len(extraLine) then extraLine = " (" & extraLine & ")"
    img = IMAGETYPE.ALERT
  end if
  return ret
end function
